Welcome to TaskSwitchXP Help

Introduction

TaskSwitchXP is an advanced task management utility that picks up where the standard Windows Alt+Tab switcher leaves off. It provides the same functionality, and adds visual styles to the dialog and also enhances it by displaying thumbnail preview of the application that will be switched to. TaskSwitchXP also has a powerful process and window management capability that allows you quickly to close/minimize applications and their groups. The unique capabilities of TaskSwitchXP make it useful for tracking down multitudinous windows, and provide insight into the way Windows and applications work.

Main Features

  • Small and FAST!
    Pure Win32 API programming guaranteed for fast running with high graphic quality. TaskSwitchXP is optimized for Windows XP. It takes a few system resources and uses less than 1 MB memory for certain!
  • Designed for Windows XP, based on XP Visual Styles
    Unlike the standard Windows switcher, TaskSwitchXP can render using Windows XP Visual Styles the end user currently has selected. TaskSwitchXP also allows standard Windows XP shadow and transparency effects, fade animation and more.
  • Window snapshots as thumbnail preview
    TaskSwitchXP displays small screenshot of the currently selected application in addition to the associated icon and caption. All child windows of the task are displayed on the preview image including modal dialogs and floating palettes.
  • Task management capability
    TaskSwitchXP provides a lot of advanced task management capabilities with handy popup menus and multiple selections.
  • Highly configurable
    TaskSwitchXP can be customized on a per-user basis with optional font and color settings, interface schemes, list and preview styles, appearance effects, hotkeys, exclusions and more.
  • Full mouse and keyboard control
    Besides the classical Alt-Tab switching, TaskSwitchXP fully supports mouse and keyboard control. You can switch and manage tasks a lot faster using the mouse wheel and shortcut keys!
  • Multilingual user interface
    TaskSwitchXP supports language extensions (Unicode based). If you would like to localize TaskSwitchXP to your native language, see instructions at TaskSwitchXP\lang\ subfolder. Then you can submit your translation at TaskSwitchXP forum!
  • Full source code available!!!
    TaskSwitchXP is distributed very free under an open source license. You can download the full source code to all versions of TaskSwitchXP here.

System requirements

TaskSwitchXP works only on Windows XP/2003 based operating systems. TaskSwitchXP requires features present only in these operating systems. All older versions of Windows are not supported! Read FAQ and forums for more information.

Copyright © 2004-2005 by Alexander Avdonin. All rights reserved.


Quick Start Guide

Getting Started

TaskSwitchXP is both user-friendly and easy-to-use, it looks familiar to most of Windows users. Although, TaskSwitchXP provides a lot of advanced features to the everyday task switching game!

Once you have installed TaskSwitchXP on your computer, ensure that TaskSwitchXP is running by pressing Alt+Tab key combination. If there are more than one tasks running, you should see the new switcher window (if not, click here).

Switching Tasks

TaskSwitchXP works entirely in the same way as the standard Windows Alt-Tab task switcher, i.e. when the hotkey combination Alt+Tab (or Alt+Shift+Tab) is pressed, TaskSwitchXP generates the list of open windows (tasks) in which the end user is working. This list of open windows is presented as a group of icons, with one outlined by a selection rectangle. As the end user continues to hold the Alt key and presses the Tab key, the selection rectangle moves to the next icon. The selected icon represents the application that Windows will bring to the foreground once the Alt key is released.

In addition to the standard method, TaskSwitchXP allows you to navigate the list using arrow and number keys, Page Up/Down, Home/End, etc. Also you can select a task from the list using the mouse wheel and cursor. TaskSwitchXP provides you the ability to delete and sort list items to quickly find required task and switch to.

Task Management

You should forget about old Windows Task Manager (Ctrl+Shift+Esc)... Now you can easily get the information on processes and quickly manage running applications directly from the switcher window!

By default, TaskSwitchXP displays the information bar with a simple description of the selected application. You can replace this description by process name and identifier that let you know, which application has created the selected window. In most cases, it is enough! If you want to see full information on process (i.e. duration, CPU time, memory usage, etc), use the advanced info tip.

To show the advanced process info tip, display the switcher window and:

  • Middle-click the preview area.
  • Press F1 or I shortcut key.
  • Right-click a blank area and choose Show Process Info from the context menu.

Right-click the preview area or selected task(s), to show the task context menu.

The task context menu contains the following commands:

  • Switch To (Enter, Space)
  • Minimize (F2, M)
  • Minimize to Tray (F3, N)
  • Cascade (C)
  • Tile Horizontally (H)
  • Tile Vertically (V)
  • Restore (F6, <)
  • Maximize (F7, >)
  • Close (F4, X)
  • End Process (F8, T)

Notes:

  • One process can own several windows! Therefore, when you will choose End Process for a task, the related tasks can be terminated also. Be ensure, that you terminate only desired tasks!
  • For safety, TaskSwitchXP does not terminate process of the Windows Shell (e.g. Explorer.exe, if you are running the standard Windows Shell). When you choose End Process for a Shell task, TaskSwitchXP posts only a close signal.

Multiple Selections

Often you want to close or restore all windows on your desktop, for this purpose you can easily mark all task items and then perform a mass action. Also you can visually tile or cascade a few windows of different applications (unlike the standard Windows desktop, which allows the user to tile/cascade only all open windows or windows of one Taskbar group at once).

You can mark some list items as multiple selected:

  • Hold Ctrl or Shift and left-click them;
  • Middle-click a list item or a blank area;
  • Hold the Shift and press an arrow key;
  • Press Insert or S shortcut key (Backspace, D - unmark).

To mark/unmark all list items, you can:

  • Double-click a blank area of the switcher window.
  • Right-click a blank area and choose Select All (or Select None) from the context menu.
  • Press A shortcut key to mark all items and Shift+A to unmark all.

Instances Switcher

TaskSwitchXP allows you quickly to switch between multitudinous tasks of one application (e.g. Internet Explorer, or Microsoft Word). In this mode, TaskSwitchXP automatically filters all instances of the currently foreground application.

You can activate Instances Switcher in a few different ways:

  • Hit the Ctrl+Alt+Tab key combination (Instance Switcher hotkey must be enabled).
  • Right-click the TaskSwitchXP tray icon and choose Instances list from the context menu.
  • Press the Instances list hotkey (by default Win+F11).
  • Assign action for TaskSwitchXP tray icon (e.g. middle-click).

Notes:

  • You can release the Ctrl key after first pressing Ctrl+Alt+Tab and then use Tab and arrow keys to navigate the list.
  • Also you can hold the Ctrl key when the switcher window is already displayed, so TaskSwitchXP will jump to the next/previous instance of the currently selected application.

Minimizing to System Tray

TaskSwitchXP allows you easy to hide a rarely used application to the System Tray and restore it now when it is needed.

To minimize an application to the System Tray, you can:

  • Right-click on a list item to show the task context menu and then select "Minimize to Tray" command.
  • Press F3 or N shortcut key to hide the currently selected tasks.
  • Right-click on the Minimize button of the main application window (option "Minimize windows to tray by right-click on Minimize button" on the General page must be enabled).
  • You can also quick hide the foreground application by the Minimize to Tray hotkey and show the last hidden now by the Restore from Tray hotkey.

Hidden application can be restored back from the System Tray by simple click on its tray icon. You can also right-click on its tray icon to show the context menu and then close this task or perform a mass action to all tasks hidden by TaskSwitchXP.


Customizing TaskSwitchXP

Configuration Tool

TaskSwitchXP is made to work the way you want! TaskSwitchXP is provided with a handy configuration tool. Almost all program settings are customizable. Of course, you can simply store numerous program preferences to a configuration file and quickly restore defaults.

By default, all settings are stored separately for each user in the system. There is need to give all users full access to program preferences. But administrators can easily change this behaviour on the General page.

Interface Languages

To switch the interface language, click on the drop-down menu by the Language box, select the new language from the list and click the Apply button. If your language is not listen, check latest translations at TaskSwitchXP forum. You can also make your own translation for other users! TaskSwitchXP uses external language files (for more information see my instructions at TaskSwitchXP\lang\ subfolder).

Interface Customization

TaskSwitchXP supports a few built-in interface schemes. TaskSwitchXP dynamically adapts to the selected Windows XP theme, provides customizable font and color settings for each user in the system. You can also choose preview and list styles, appearance effects, opacity level of the switcher window and more. You can make your everyday environment to look whichever you want!

Alt-Tab Hooking

By default, TaskSwitchXP uses standard Windows services to replace Alt-Tab. This method is very simple! But it does not work if another application already uses it (e.g. hotkey managers, other switchers, some 3D games). To avoid this problem, you can use option "Enable low-level keyboard hook to replace Alt-Tab". If it is enabled, TaskSwitchXP continually filters system keyboard input events and monitors wanted keystrokes independently of standard services. In most cases it is a troubleshooting option!

Using Exclusions

TaskSwitchXP allows you to select tasks which will not be displayed in the Alt-Tab list or on preview. This is useful if you want TaskSwitchXP to ignore certain windows or applications. Also, some programs use non-standard ways to paint itself. As a result TaskSwitchXP can not take exact snapshots of these programs. To avoid this problem, you can assign a exclusion rule.

There are three sufficient rules:

  • Process name (exe name without path).
  • Window class (special window name used by Windows).
  • Window title (text showed on the window titlebar).

To add an exlusion rule to TaskSwitchXP:

  1. Run task which you want to exclude.
  2. Open the TaskSwitchXP configuration tool and activate the Exclusions page.
  3. Press the New button, Exclusion dialog is now displayed.
  4. Select a window from the applications tree, and assign exclusion requisites.
  5. Press OK in the Exclusion dialog, apply changes and check your TaskSwitchXP rule now!


TaskSwitchXP Control

TaskSwitchXP Shortcuts

System-wide Hot Keys

Hot Key | Description
Alt+Tab Alt+Shift+Tab | Switch to the next/previous task.
Ctrl+Alt+Tab Ctrl+Alt+Shift+Tab | Switch to the next/previous instance of the foreground application.
Win+F12 | Show the list all open applications windows ("sticky" mode).
Win+F11 | Show the instances list of the foreground application ("sticky" mode).
Win+Ctrl+Alt+C | Run TaskSwitchXP Configuration tool.
Win+Ctrl+Alt+H | Show/Hide the TaskSwitchXP System Tray icon.
Win+Ctrl+Alt+X | Exit TaskSwitchXP.

Task List Navigation

Shortcut Key | Description
Home, End Page Up, Page Down Arrow Keys | Task list navigation.
1, ..., 9, 0 | Select task number 1, ..., 9, 10
Insert, S | Mark current item as multiple selected and go next.
Backspace, D | Unmark current item if it was marked as multiple selected and go back.
Shift + Arrow Keys | Mark current item as multiple selected and navigate the list.
A | Mark all items to perform a mass action.
Shift+A | Unmark all items.
Ctrl+A Ctrl+Shift+A | Mark/Unmark all instances of the selected application.
Delete | Remove selected task(s) from the list.

Task Management

Shortcut Key | Description
Space, Enter | Switch to the selected task.
F2, M | Minimize selected task(s).
F3, N | Minimize selected task(s) to the System Tray.
C | Cascade selected tasks on the Desktop.
V | Tile vertically selected tasks on the Desktop.
H | Tile horizontally selected tasks on the Desktop.
F6, < | Restore selected task(s).
F7, > | Maximize selected task(s).
F4, X | Close selected task(s).
F8, T | Terminate selected task(s).

Other

Shortcut Key | Description
F1, I | Show/Hide advanced process information.
F5, R | Update task preview.
F9, - | Sort the task list by title.
F10, + | Sort the task list by application (groups on the taskbar).
E | Explore .EXE path of the selected task.
App (or Menu) | Show context menu for selected task(s).
Z, Y | Enable temporary Alt-Tab "sticky" mode.
P | Preferences - run TaskSwitchXP configuration tool.


TaskSwitchXP FAQ

Q: Just wondering why WinXP is required? I'm looking for such an utility for Win2K.
A: TaskSwitchXP requires features present only in the newest Windows XP/2003 operating systems. Windows 9x/NT/2000 doesn't support the window preview feature (for more information see PrintWindow API in the PlatformSDK documentation). I'm planning a Lite Edition without previews for Win2k! Sign up to my newsletter to be informed of updates.
Q: Program doesn't react to ALT-TAB combination at all.
A: Maybe another taskswitch-application is running. Maybe one of these programs is installed on your computer: Microsoft PowerToy TaskSwitcher, AltSwitch, Expire, etc. Also it may be a hotkey manager if it uses Alt+Tab or Alt+Shift+Tab key combinations. If not, try to enable option "Use low-level keyboard hook to replace Alt-Tab" on the Hotkeys page.
Q: What is error message "Could not register hotkey... <parameters>"?
A: Maybe another application has already registered this key combination! Try to disable guilty application, or reassign/remove this combination for TaskSwitchXP on the Hotkeys page.
Q: TaskSwitchXP v2.0 seems much slower than v1.0.27! What accounts for this?
A: It's true, TaskSwitchXP 2.0 uses more heavy algorithms. But you can reconfigure TaskSwitchXP 2.0! There are a few options that have the highest influence on TaskSwitchXP speed:
  1. Disable option "Include Windows Taskbar to preview image" or use the "Window" preview mode (Preview page).
  2. Disable all additional appearance effects: shadow, transparency, fade in/out (Appearance page).
  3. Disable Visual styles for TaskSwitchXP (option "Force use TaskSwitchXP Classic style" on the Appearance page).
  4. Also you can remove caption and info panes (Advanced page).
Q: How can I hasten window snapshot appearance?
A: At first launching TaskSwitchXp sets the preview generation delay depending on the system keyboard repeat delay (Control Panel -> Keyboard, Repeat Delay). It may vary from 50 to 200 milliseconds. Afterwards you can change it manually on the Preview page!
EDIT: Since version 2.06, the initial value of the preview generation delay does not depend on the system keyboard repeat delay! TaskSwitchXP 2.06 generates previews in a separate thread..
Q: On the preview of minimized windows only the window bar is visible. How about displaying the last full-sized preview?
A: If it is done, TaskSwitchXP will work not so fast and can corrupt the everyday work of your system. Do you really want it? Look at TaskSwitchXP forums and feature requests for more information.
Q: I am running a multi-monitor setup and there are no preview images for programs running on the second monitor. Is this a limitation of the current version or a bug appearing in my system constellation?
A: It's not a bug! Currently you must enable the "Window" preview mode. Currently TaskSwitchXP shows previews for all windows on the whole virtual screen only in the "Window" mode. There are some small troubles with different screen resolutions and with some apps which place their windows abroad visible screen. Maybe I'll fix this afterwards.
Q: TaskSwitchXP doesn't capture <application name> window (show black screen)! What's the stuff?
A: Sorry, I can't help you. It's a bug of PrintWindow API, i.e. it's Microsoft bug (for more information see PrintWindow API in the PlatformSDK documentation). This mistake was marked with some Java-applications (JBuilder, Java Web Start, etc) and some other.
Q: I'm very interested in your products. I think it'll be a good idea to publish TaskSwitchXP on a software CD.
A: Of course, you can. But if you will change the original TaskSwitchXP distribution you must reproduce my copyright notice and all materials provided with my distribution (readme, license, history). See the License.txt file for more information.
Q: TaskSwitchXP is really a good tiny tool, so would you mind I localize it to my native language?
A: TaskSwitchXP 2.0 supports multilingual user interface (*.LNG files). Read my instructions in TaskSwitchXP\lang\_Translation.txt . Then you can submit your translation at TaskSwitchXP forum. Let's go!
Q: I like your program, it uses MFC? I want to write something like that on Visual Basic. Can you help me?
A: I don't teach programming. I hate MFC: WinAPI rulezzz! VB and Delphi are not good programming languages for such tools, IMHO!!!


History of TaskSwitchXP

Version 2.0 build 6 (July 18, 2005)

  • Considerable preview speed improvement!
  • New interface languages (+17!).
  • Ability to add minimized to tray windows to the end of Alt-Tab list.
  • Some new shortcut keys (preferences, sticky, etc).
  • Some new command line parameters.
  • Some new secret/test features.. ;)
  • One more small issue with minimizing to tray was fixed.
  • One more small issue with colors was fixed.
  • Some small bugs were fixed.

Version 2.0 build 5 (April 12, 2005)

  • First official 2.0 release: new homepage, new features and languages!
  • First German translation (by Markus Schuster aka eVo)!
  • First Russian translation!
  • Multilingual user interface!!!
  • New help docs were added.
  • Default preview mode for multiple monitors was fixed.
  • Small bug with restricted user accounts was fixed.
  • Small bug with default colors were fixed.
  • Small bug with minimizing to tray was fixed.
  • Some small bugs were fixed.

Version 2.0 beta 4 (February 25, 2005)

  • TaskSwitchXP now restores tray icons after Explorer crashes.
  • Middle-click on blank area marks item as multiple selected.
  • Some bugs with tray icon actions were fixed.
  • Some bugs with window enumeration were fixed.
  • Memory leak with rounded selection style was fixed.
  • Some stability and performance fixes.

Version 2.0 beta 3 (February 14, 2005)

  • List multiple selections.
  • Context menus.
  • New window and task management commands.
  • List sorting by title and filename.
  • 5 new interface schemes.
  • Configurable info pane formats.
  • Configurable info pane and list fonts.
  • New list selection style.
  • Menus for minimized to system tray apps.
  • New option "Keep TaskSwitchXP tray icons from WinXP auto-hide feature".
  • New option "Show on active monitor".
  • New option "Exclude all layered windows from preview" (troubleshooting).
  • "Sticky" mode for alt-tab.
  • Fade out animation.
  • Some new shortcut keys.
  • Some default settings were changed.
  • Bugs with window enumeration were fixed!!!
  • Some bugs with long exe paths were fixed.
  • Some bugs with hot-tracking selection were fixed.
  • Bug with Alt+Win+[Shift]+Tab was fixed.
  • Bug with minimized MSN Messenger Conversation window was fixed.
  • Some small bugs with minimizing to tray were fixed.
  • Some small bugs were fixed.
  • Some stability and performance fixes.

Version 1.1 alpha 2 (January 19, 2005)

  • New improved tray menu with quick preferences.
  • TaskSwitchXP now detects Ms PowerToy TaskSwitcher running.
  • Minimizing windows to system tray.
  • Desktop wallpaper caching.
  • Old v1.0 style of preview image (without desktop background).
  • Fade in animation.
  • Cursor hand for hot-tracked item.
  • Task closing and killing.
  • Some new shortcut keys.
  • Some default settings were changed.
  • Some bugs with Instance Switcher were fixed.
  • Some small bugs were fixed.
  • Some stability and performance fixes.

Version 1.1 alpha 1 (December 14, 2004)

  • New configurator interface.
  • Advanced settings.
  • TaskSwitchXP exclusions.
  • Info pane settings.
  • Instance switcher.
  • Low level AltTab hooking.
  • Configurable hotkeys.
  • Extended task information (middle-click on the preview image or press F1).
  • New "Window" preview style.
  • Option "Don't create exclusion region for window preview" was removed.
  • Bug with multiple instances of configurator was fixed.
  • Bug with service messages was fixed.
  • Some small bugs were fixed.
  • Some stability and performance fixes.

Version 1.1 alpha 0 (November 8, 2004)

  • TaskSwitchXP draw modes (+ PowerToy TaskSwitcher style).
  • Vertical window titles list and small icons list.
  • Configurable list sizes, selection style and colors.
  • Preview of all application windows.
  • Preview images caching.
  • Preview live update.
  • "Desktop" preview mode.
  • Configurable generation delay, size and position of preview image.
  • Multiple monitors support.
  • System tray icon.

Old versions 1.0.x history...


Contact Information

Bug reports

You can post me bug reports via SourceForge Bug Tracking System or email.

Before submitting a bug, please verify that there are no open bugs with the same report. Also, please check the latest changelog to see if the bug may have been fixed recently.

Please include the following in the report:

  1. Version of TaskSwitchXP you are using.
  2. Error message you get if any.
  3. A script that reproduces this bug if acceptable.
  4. A screen shot if something is wrong with the user interface.

Feature requests

You can post me feature suggestions for future versions of TaskSwitchXP via SourceForge Feature Requests Tracking System or email.

Keep in mind that there are a feature that could have been added, but most of them will just make TaskSwitchXP huge, and no one wants that.

If you think it will be a useful feature, please give a detailed description of the feature you are requesting and make sure you don't post double requests.

If you have added a feature yourself, you can post me the source code via email.

Contact

  • Web site: http://www.ntwind.com/taskswitchxp/
  • Project page: http://sourceforge.net/projects/taskswitchxp/
  • Support forums: http://www.ntwind.com/forum/
  • Support email: alexander@ntwind.com


TaskSwitchXP License

License Agreement

Copyright © 2004-2005 by Alexander Avdonin. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
  3. Neither the name of the author nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Credits

TaskSwitchXP uses:

  • FOOOD's Icons (with official permission)
  • Nullsoft Scriptable Install System 2.0
  • The Ultimate Packer for eXecutables 1.25

Translations

My sincere gratitude to all people localized TaskSwitchXP:

  • Ruben Sanabra Ramos - Catalan
  • LoBid, Banxu, kluivert - Chinese (Simplified)
  • H@rRy HU4nG aka TTrate - Chinese (Traditional)
  • Iwo Jimy - Croatian
  • Geralt & Merlin - Czech
  • Jerome Glatigny aka DarkSage, Wildbear - French
  • Markus Schuster aka eVo - German
  • Sergio Novella - Italian
  • Bac - Korean
  • Zsolti, emotions - Magyar (Hungarian)
  • PintSki - Nederlands (Dutch)
  • Toszcze - Polish
  • Peter Vavro <Gudas> - Slovak
  • Alvaro Quezada Arce - Spanish LA
  • Kela - Ukrainian

Special thanks

Thanks to the following people (in no particular order):

  • SourceForge team
  • Ivan Pivovarov
  • Konstantin Kuleshevich
  • Andre Pinheiro
  • Jason Schmidt
  • ... and all people who gave suggestions/bugreports.